local L = LibStub("AceLocale-3.0"):GetLocale("ProximoGrid", true)
ProximoGridIndicator = {}
ProximoGridIndicator.__index = ProximoGridIndicator

function ProximoGridIndicator.NewModule(shortName, name, db, standardStatus)
	local indicator = {};
	setmetatable(indicator,ProximoGridIndicator);
	indicator.name = shortName;
	indicator.self = indicator;
	ProximoGrid.Indicators[shortName] = {
		["name"] = name,
		["enabled"] = true,
		["module"] = indicator,
	};
	if (standardStatus == nil) then
		standardStatus = {};
	end
	if (db == nil) then
		db = {};
	end
	ProximoGrid.profileDefault.indicators[shortName] = {
		["name"] = name,
		["status"] = {},
		["db"] = db
	}
	for number, statusName in pairs(standardStatus) do
		ProximoGrid.profileDefault.indicators[shortName].status[statusName] = true;
	end
	indicator.frame = CreateFrame("Frame");
	indicator.frame:Hide();
	indicator.self = status;
	indicator.frame:SetScript("OnEvent", function() 
		status[event](event, arg1, arg2, arg3, arg4, arg5, arg6, arg7, arg8, arg9, arg10, arg11, arg13, arg14, arg15, arg16);
	end);
	
	return indicator;
end

function ProximoGridIndicator:RegisterEvent(event)
	if (string.sub(event, 1, 11) == "PROXIMOGRID") then
		ProximoGrid:RegisterProximoGridEvent(event, self.OnEvent, self);
	else
		self.frame:RegisterEvent(event);
	end
end

function ProximoGridIndicator:UnregisterEvent(event)
	if (string.sub(event, 1, 11) == "PROXIMOGRID") then
		ProximoGrid:UnregisterProximoGridEvent(event, self);
	else
		self.frame:UnregisterEvent(event);
	end
end

function ProximoGridIndicator:OnEvent(event, ...)
	self[event](event,...);
end

function ProximoGridIndicator:WithAllFrames(func)
	for number,uf in pairs(ProximoGrid.UnitFrames) do
		func(uf);
	end
end

function ProximoGridIndicator:ResetIndicator(frame)

end

function ProximoGridIndicator:SetIndicator(frame, range, color, text,  value, maxValue, texture, start, duration, stack)

end

function ProximoGridIndicator:CreateIndicator(frame)
	
end

function ProximoGridIndicator:OnInit()
	self.db = ProximoGrid.db.profile.indicators[self.name].db;
	self:OnInitialize();
end

function ProximoGridIndicator:OnInitialize()

end

function ProximoGridIndicator:GetOptions()
	return self.options;
end

function ProximoGridIndicator:GetStandardStatus()
	return self.standardStatus;
end