local L = LibStub("AceLocale-3.0"):GetLocale("ProximoGrid", true)
local BabbleClass = LibStub:GetLibrary("LibBabble-Class-3.0")
local BC = BabbleClass:GetLookupTable()
local defaultDB = {
	buffGroups = {
		[L["Dispel"]] = {
			type = "buff",
			color = {0, 0, 1, 1},
			priority = 90,
			classFilter = {
				[BC["Druid"]] = true,
				[BC["Hunter"]] = true,
				[BC["Mage"]] = true,
				[BC["Paladin"]] = true,
				[BC["Priest"]] = true,
				[BC["Rogue"]] = true,
				[BC["Shaman"]] = true,
				[BC["Warlock"]] = true,
				[BC["Warrior"]] = true,
				[BC["Deathknight"]] = ture
			},
			auras = {
				[select(1,GetSpellInfo(41450))] = true, --Blessing of Protection
				[select(1,GetSpellInfo(2825))] = true, --Bloodlust
				[select(1,GetSpellInfo(32182))] = true, --Heroism
				[select(1,GetSpellInfo(29166))] = true, --Innervate
				[select(1,GetSpellInfo(44416))] = true, --Pain Suppression
				[select(1,GetSpellInfo(10060))] = true, --Power Infusion
				[select(1,GetSpellInfo(12472))] = true, --Icy Veins
				[select(1,GetSpellInfo(16188))] = true --Nature's Swiftness
			}
		},
		[L["Mass Dispel"]] = {
			type = "buff",
			color = {0.5, 0.5, 1, 1},
			priority = 90,
			classFilter = {
				[BC["Druid"]] = true,
				[BC["Hunter"]] = true,
				[BC["Mage"]] = true,
				[BC["Paladin"]] = true,
				[BC["Priest"]] = true,
				[BC["Rogue"]] = true,
				[BC["Shaman"]] = true,
				[BC["Warlock"]] = true,
				[BC["Warrior"]] = true,
				[BC["Deathknight"]] = ture
			},
			auras = {
				[select(1,GetSpellInfo(45438))] = true, --Ice Block
				[select(1,GetSpellInfo(642))] = true --Divine Shield
			}
		},
		[L["Other buffs"]] = {
			type = "buff",
			color = {1, 0, 0, 1},
			priority = 90,
			classFilter = {
				[BC["Druid"]] = true,
				[BC["Hunter"]] = true,
				[BC["Mage"]] = true,
				[BC["Paladin"]] = true,
				[BC["Priest"]] = true,
				[BC["Rogue"]] = true,
				[BC["Shaman"]] = true,
				[BC["Warlock"]] = true,
				[BC["Warrior"]] = true,
				[BC["Deathknight"]] = ture
			},
			auras = {
				[select(1,GetSpellInfo(34471))] = true, --The Beast Within
				[select(1,GetSpellInfo(10250))] = true, --Drink
				[select(1,GetSpellInfo(12051))] = true --Evocation
			}
		},
		[L["Crowd Control"]] = {
			type = "debuff",
			color = {1, 0, 0, 1},
			priority = 90,
			classFilter = {
				[BC["Druid"]] = true,
				[BC["Hunter"]] = true,
				[BC["Mage"]] = true,
				[BC["Paladin"]] = true,
				[BC["Priest"]] = true,
				[BC["Rogue"]] = true,
				[BC["Shaman"]] = true,
				[BC["Warlock"]] = true,
				[BC["Warrior"]] = true,
				[BC["Deathknight"]] = ture
			},
			showIfMissing = false,
			auras = {
				[select(1,GetSpellInfo(118))] = true, --Polymorph
				[select(1,GetSpellInfo(5782))] = true, --Fear
				[select(1,GetSpellInfo(710))] = true, --Banish
				[select(1,GetSpellInfo(2094))] = true, --Blind
				[select(1,GetSpellInfo(6358))] = true, --Seduction
				[select(1,GetSpellInfo(6789))] = true, --Death Coil
				[select(1,GetSpellInfo(5484))] = true, --Howl of Terror
				[select(1,GetSpellInfo(8122))] = true, --Psychic Scream
				[select(1,GetSpellInfo(3355))] = true, --Freezing Trap Effect
				[select(1,GetSpellInfo(2637))] = true, --Hibernate
				[select(1,GetSpellInfo(19386))] = true, --Wyvern Sting
				[select(1,GetSpellInfo(20066))] = true, --Repentance
			}
		},
		[L["Root"]] = {
			type = "debuff",
			color = {1, 0, 0, 1},
			priority = 90,
			classFilter = {
				[BC["Druid"]] = true,
				[BC["Hunter"]] = true,
				[BC["Mage"]] = true,
				[BC["Paladin"]] = true,
				[BC["Priest"]] = true,
				[BC["Rogue"]] = true,
				[BC["Shaman"]] = true,
				[BC["Warlock"]] = true,
				[BC["Warrior"]] = true,
				[BC["Deathknight"]] = ture
			},
			showIfMissing = false,
			auras = {
				[select(1,GetSpellInfo(122))] = true, --Frost Nova
				[select(1,GetSpellInfo(339))] = true, --Entangling Roots
				[select(1,GetSpellInfo(23694))] = true, --Improved Hamstring
				[select(1,GetSpellInfo(33395))] = true, --Freeze
				[select(1,GetSpellInfo(45334))] = true, --Feral Charge Effect
				[select(1,GetSpellInfo(19306))] = true, --Counterattack
				[select(1,GetSpellInfo(12494))] = true --Frostbite
			}
		},
		[L["Slowing"]] = {
			type = "debuff",
			color = {1, 0, 0, 1},
			priority = 90,
			classFilter = {
				[BC["Druid"]] = true,
				[BC["Hunter"]] = true,
				[BC["Mage"]] = true,
				[BC["Paladin"]] = true,
				[BC["Priest"]] = true,
				[BC["Rogue"]] = true,
				[BC["Shaman"]] = true,
				[BC["Warlock"]] = true,
				[BC["Warrior"]] = true,
				[BC["Deathknight"]] = ture
			},
			showIfMissing = false,
			auras = {
				[select(1,GetSpellInfo(1715))] = true, --Hamstring
				[select(1,GetSpellInfo(18223))] = true, --Curse of Exhaustion
				[select(1,GetSpellInfo(8056))] = true, --Frost Shock
				[select(1,GetSpellInfo(3408))] = true, --Crippling Poison
				[select(1,GetSpellInfo(2974))] = true --Wing Clip
			}
		},
		[L["Healing Reduction"]] = {
			type = "debuff",
			color = {1, 1, 0, 1},
			priority = 90,
			classFilter = {
				[BC["Druid"]] = true,
				[BC["Hunter"]] = true,
				[BC["Mage"]] = true,
				[BC["Paladin"]] = true,
				[BC["Priest"]] = true,
				[BC["Rogue"]] = true,
				[BC["Shaman"]] = true,
				[BC["Warlock"]] = true,
				[BC["Warrior"]] = true,
				[BC["Deathknight"]] = ture
			},
			showIfMissing = false,
			auras = {
				[select(1,GetSpellInfo(12294))] = true, --Mortal Strike
				[select(1,GetSpellInfo(13218))] = true, --Wound Poison
				[select(1,GetSpellInfo(19434))] = true, --Aimed Shot
				[select(1,GetSpellInfo(56112))] = true --Furious Attacks
			}
		}
		
	},
	buffTypes = {
		[L["Magic"]] = {
			color = {.2, .6, 1, 1},
			priority = 90
		},
		[L["Poison"]] = {
			color = {  0, .6,  0, 1 },
			priority = 90
		},
		[L["Disease"]] = {
			color = { .6, .4,  0, 1 },
			priority = 90
		},
		[L["Curse"]] = {
			color = { .6,  0,  1, 1 },
			priority = 90
		},
	},
	useClassColors = true,
	color = {1, 1, 1, 1},
	priority = 90
	
};

StatusAuras = ProximoGridStatus.NewModule("StatusAuras", defaultDB);

StatusAuras.header = L["Buffs/Debuffs"];
StatusAuras.options = {
	buffTypes = {
		type = "group",
		name = L["Buff Types"],
		desc = L["Options for Buff Types."],
		args = {}
	},
	buffGroups = {
		type = "group",
		name = L["Buff Groups"],
		desc = L["Options for Buff Groups."],
		args = {
			addGroup = {
				type = "group",
				name = L["Add Group"],
				desc = L["Add a new group."],
				order = 100,
				args = {
					addBuffGroup = {
						type = "text",
						name = L["Add Buff Group"],
						desc = L["Add a new group."],
						get = false,
						usage = L["<aura name>"],
						set = function(value)
							if (StatusAuras.db.buffGroups[value] ~= nil and StatusAuras.db.buffGroups[value].removed == true) then
								StatusAuras.db.buffGroups[value].removed = nil;
								StatusAuras:SetupOptions(value);
								return;
							end
							if (value=="" or value == " " or StatusAuras.db.buffGroups[value] ~= nil or StatusAuras.db.buffTypes[value] ~= nil) then
								return;
							end
							StatusAuras.db.buffGroups[value] = {
								type = "buff",
								color = {1, 0, 0, 1},
								priority = 90,
								classFilter = {
									[BC["Druid"]] = true,
									[BC["Hunter"]] = true,
									[BC["Mage"]] = true,
									[BC["Paladin"]] = true,
									[BC["Priest"]] = true,
									[BC["Rogue"]] = true,
									[BC["Shaman"]] = true,
									[BC["Warlock"]] = true,
									[BC["Warrior"]] = true,
									[BC["Deathknight"]] = ture
								},
								auras = {}
							}
							StatusAuras:SetupOptions(value);
						end
					},
					addDefuffGroup = {
						type = "text",
						name = L["Add Debuff Group"],
						desc = L["Add a new group."],
						get = false,
						usage = L["<aura name>"],
						set = function(value)
							if (StatusAuras.db.buffGroups[value] ~= nil and StatusAuras.db.buffGroups[value].removed == true) then
								StatusAuras.db.buffGroups[value].removed = nil;
								StatusAuras:SetupOptions(value);
							end
							if (value=="" or value == " " or StatusAuras.db.buffGroups[value] ~= nil or StatusAuras.db.buffTypes[value] ~= nil) then
								return;
							end
							StatusAuras.db.buffGroups[value] = {
								type = "debuff",
								color = {1, 0, 0, 1},
								priority = 90,
								classFilter = {
									[BC["Druid"]] = true,
									[BC["Hunter"]] = true,
									[BC["Mage"]] = true,
									[BC["Paladin"]] = true,
									[BC["Priest"]] = true,
									[BC["Rogue"]] = true,
									[BC["Shaman"]] = true,
									[BC["Warlock"]] = true,
									[BC["Warrior"]] = true,
									[BC["Deathknight"]] = ture
								},
								auras = {}
							}
							StatusAuras:SetupOptions(value);
						end
					}
				},
			},
			removeGroup = {
				type = "group",
				name = L["Remove Group"],
				desc = L["Remove a group you have added."],
				order = 100,
				args = {},
			},
		}
	}
}

function StatusAuras:PROXIMOGRID_UNIT_AURA_ADDED(unitID)
	StatusAuras:UpdateAuras(unitID);
end

function StatusAuras:PROXIMOGRID_UNIT_AURA_REMOVED(unitID)
	StatusAuras:UpdateAuras(unitID);
end

function StatusAuras:PROXIMOGRID_UNIT_AURA_UPDATED(unitID)
	StatusAuras:UpdateAuras(unitID);
end

function StatusAuras:PROXIMOGRID_UNIT_DIED(unitGUID)
	for groupName, groupData in pairs(StatusAuras.db.buffGroups) do
		StatusAuras:SendStatusLost(unitGUID, "statusAura"..groupName);
	end
end

function StatusAuras:UpdateAuras(unitID)
	local unitAuras = ProximoGrid.Opponents[unitID].unitAuras;
	local unitClass = ProximoGrid.Opponents[unitID].unitClass;
	local unitName = ProximoGrid.Opponents[unitID].unitName;
	for groupName, groupData in pairs(StatusAuras.db.buffGroups) do
		--Aura group loop
		if (groupData.removed == true) then
		elseif (groupData.classFilter[unitClass] == nil or groupData.classFilter[unitClass]) then
			local auras = unitAuras[groupData.type.."s"];
			local foundAura = (groupData.showIfMissing~=nil and groupData.showIfMissing);
			local auraFound = "";
			--Aura group auras loop
			for groupAuraName, enabled in pairs (groupData.auras) do
				--If the aura is in the group
				if (enabled) then
					if (auras[groupAuraName] ~= nil) then
						--If "missing" is disabled then break here
						if (groupData.showIfMissing==nil or not groupData.showIfMissing) then
							foundAura = true;
							auraFound = groupAuraName;
							break;
						end
					else
						--If "missing" is enabled then break here
						if (groupData.showIfMissing~=nil and groupData.showIfMissing) then
							foundAura = false;
							auraFound = groupAuraName;
							break;
						end
					end
				end
			end
			--If "missing" is enabled and foundAura is false or "missing" is disabled and foundAura is true
			if (foundAura and (groupData.showIfMissing==nil or not groupData.showIfMissing) or not foundAura and groupData.showIfMissing~=nil and groupData.showIfMissing) then
				local r, g, b, a = groupData.color[1], groupData.color[2], groupData.color[3], groupData.color[4];
				local auraIcon;
				if (auras[auraFound] == nil) then
					local name, rank, icon, cost, isFunnel, powerType, castTime, minRange, maxRange = GetSpellInfo(auraFound)
					if (icon ~= nil) then
						auraIcon = icon;
					else
						
						auraIcon = "Interface\\Icons\\INV_Misc_QuestionMark";
					end
				else
					auraIcon = auras[auraFound].auraIcon;
				end
				if (groupData.showIfMissing) then
					if (StatusAuras:SendStatusGained(unitID, unitName, "statusAura"..groupName, groupData.priority, true, {["r"] = r,["g"] = g,["b"] = b, ["a"] = a}, auraFound,  0, 0, auraIcon, 0, 0, 0)) then
						StatusAuras:SendAnnouncement(string.format(L["%s lost %s"], unitName, auraFound), "announcementAura"..groupName);
					end
				else
					local expTime;
					
					if (auras[auraFound].auraExpirationTime == nil or auras[auraFound].auraDuration) then
						expTime = 0;
					else
						expTime = auras[auraFound].auraExpirationTime - auras[auraFound].auraDuration;
					end
					if (StatusAuras:SendStatusGained(unitID, unitName, "statusAura"..groupName, groupData.priority, true, {["r"] = r,["g"] = g,["b"] = b, ["a"] = a}, auraFound,  0, 0, auraIcon, expTime, auras[auraFound].auraDuration, auras[auraFound].auraCount)) then
						StatusAuras:SendAnnouncement(string.format(L["%s gained %s"], unitName, auraFound), "announcementAura"..groupName);
					end
				end
			else
				StatusAuras:SendStatusLost(unitID, "statusAura"..groupName);
			end
		end
	end
	local typesFound= {};
	for auraName, auraData in pairs(unitAuras.debuffs) do
		if (auraData.auraDebuffType ~= nil) then
			typesFound[auraData.auraDebuffType] = auraData;
		end
	end
	
	for typeName, typeData in pairs(StatusAuras.db.buffTypes) do
		if (typesFound[typeName] ~= nil) then
			local r,g,b,a = typeData.color[1], typeData.color[2], typeData.color[3], typeData.color[4];
			StatusAuras:SendStatusGained(unitID, unitName, "statusAura"..typeName, typeData.priority, true, {["r"] = r,["g"] = g,["b"] = b, ["a"] = a}, typesFound[typeName].auraName,  0, 0, typesFound[typeName].auraIcon, 0, 0, 0);
		else
			StatusAuras:SendStatusLost(unitID, "statusAura"..typeName);
		end
	end
	
end

function StatusAuras:OnDisable()
	StatusAuras:UnregisterEvent("PROXIMOGRID_UNIT_AURA_ADDED");
	StatusAuras:UnregisterEvent("PROXIMOGRID_UNIT_AURA_REMOVED");
	StatusAuras:UnregisterEvent("PROXIMOGRID_UNIT_AURA_UPDATED");
	StatusAuras:UnregisterEvent("PROXIMOGRID_UNIT_DIED");
end

function StatusAuras:OnInitialize()
	StatusAuras:SetupOptions();
end

function StatusAuras:OnEnable()
	StatusAuras:RegisterEvent("PROXIMOGRID_UNIT_AURA_ADDED");
	StatusAuras:RegisterEvent("PROXIMOGRID_UNIT_AURA_REMOVED");
	StatusAuras:RegisterEvent("PROXIMOGRID_UNIT_AURA_UPDATED");
	StatusAuras:RegisterEvent("PROXIMOGRID_UNIT_DIED");
end

function StatusAuras:SetupOptions(groupName)
	for k, v in pairs(StatusAuras.db.buffGroups) do
		if (v.removed == true) then
		elseif (groupName == nil or groupName == k) then
			StatusAuras:RegisterStatus("statusAura"..k, string.format(L["%s Group: %s"], v.type:sub(1,1):upper()..v.type:sub(2), k));
			StatusAuras:RegisterAnnouncement("announcementAura"..k, string.format(L["%s Group: %s"], v.type:sub(1,1):upper()..v.type:sub(2), k));
			StatusAuras.options.buffGroups.args.removeGroup.args[k] = {
				type = "execute",
				name = string.format(L["Remove %s"], k),
				desc = string.format(L["Remove %s from this group."], k),
				func = function()
					StatusAuras:UnregisterStatus("statusAura"..k, k);
					StatusAuras:UnregisterAnnouncement("announcementAura"..k, k);
					if (defaultDB.buffGroups[k] == nil) then
						StatusAuras.db.buffGroups[k] = nil;
					else
						StatusAuras.db.buffGroups[k].removed = true;
					end
					StatusAuras.options.buffGroups.args[k] = nil;
					StatusAuras.options.buffGroups.args.removeGroup.args[k] = nil;
				end,
				order = 3
			};
			StatusAuras.options.buffGroups.args[k] = {
				type = "group",
				name = L[v.type]..": "..k,
				desc = string.format(L["Options for %s."],k),
				order = 10,
				args = {
					color = {
						type = "color",
						name = L["Color"],
						desc = L["Color."],
						get = function()
							local tmpColor = v.color;
							return tmpColor[1], tmpColor[2], tmpColor[3], tmpColor[4]
						end,
						set = function(r, g, b, a)
							local tmpColor = v.color;
							tmpColor[1], tmpColor[2], tmpColor[3], tmpColor[4] = r, g, b, a or 1
						end,
						hasAlpha = false,
						order = 1,
					},
					alpha = {
						type = "range",
						name = L["Alpha"],
						desc = L["Alpha."],
						get = function()
							return v.color[4];
						end,
						set = function(value)
							v.color[4] = value;
						end,
						min = 0,
						max = 1,
						step = 0.01,
						order = 10,
					},
					priority = {
						type = "range",
						name = L["Priority"],
						desc = L["Priority."],
						get = function()
							return v.priority;
						end,
						set = function(value)
							v.priority = value;
						end,
						min = 1,
						max = 99,
						step = 1,
						order = 20,
					},
					classFilter = {
						type = "group",
						name = L["Class Filter"],
						desc = L["Which classes this groups should be active on."],
						order = 40,
						args = {}
					},
					addAura = {
						type = "group",
						name = L["Add Aura"],
						desc = L["Add a new buff/debuff to this group."],
						order = 50,
						args = {
							name = {
								type = "text",
								name = L["Add Aura"],
								desc = L["Add a new buff/debuff to this group."],
								get = false,
								usage = L["<aura name>"],
								set = function(value)
									if (value=="" or value == " " or v.auras[value] ~= nil) then
										return;
									end
									v.auras[value] = true;
									StatusAuras.options.buffGroups.args[k].args.auras.args[value] = {
										type = "toggle",
										name = value,
										desc = string.format(L["Toggle %s."], value),
										get = function()
											return v.auras[value];
										end,
										set = function(val)
											v.auras[value] = val
										end,
									}
									
									StatusAuras.options.buffGroups.args[k].args.removeSpell.args[value] = {
										type = "execute",
										name = string.format(L["Remove %s"], value),
										desc = string.format(L["Remove %s from this group."], value),
										func = function()
											if (defaultDB.buffGroups[k] == nil or defaultDB.buffGroups[k].auras[value]==nil) then
												v.auras[value] = nil;
											else
												v.auras[value] = false;
											end
											StatusAuras.options.buffGroups.args[k].args.auras.args[value] = nil;
											StatusAuras.options.buffGroups.args[k].args.removeSpell.args[value] = nil;
										end,
										order = 3
									}
									
								end
							}
						}
					},
					removeSpell = {
						type = "group",
						name = L["Remove aura"],
						desc = L["Remove a buff/debuff from this group."],
						order = 60,
						args = {}
					},
					auras = {
						type = "group",
						name = L["Auras"],
						desc = L["Options for auras."],
						order = 40,
						args = {}
					}
				}
			}
			if (v.type == "debuff") then
				StatusAuras.options.buffGroups.args[k].args.showIfMissing = {
					type = "toggle",
					name = L["Show If Missing"],
					desc = L["Show this status if any of the buffs/debuffs in the group is not active on the unit."],
					get = function()
						return v.showIfMissing;
					end,
					set = function(value)
						v.showIfMissing = value
					end,
					order = 30
				}
			end

			for class, enabled in pairs (v.classFilter) do
				StatusAuras.options.buffGroups.args[k].args.classFilter.args[class] = {
					type = "toggle",
					name = class,
					desc = string.format(L["Toggle %s."], class),
					get = function()
						return v.classFilter[class];
					end,
					set = function(value)
						v.classFilter[class] = value
					end,
				}
			end

			for spell, enabled in pairs (v.auras) do
				StatusAuras.options.buffGroups.args[k].args.auras.args[spell] = {
					type = "toggle",
					name = spell,
					desc = string.format(L["Toggle %s"], spell),
					get = function()
						return v.auras[spell];
					end,
					set = function(value)
						v.auras[spell] = value
					end,
				}
				if (defaultDB.buffGroups[k] == nil or defaultDB.buffGroups[k].auras[spell]==nil) then
					StatusAuras.options.buffGroups.args[k].args.removeSpell.args[spell] = {
						type = "execute",
						name = string.format(L["Remove %s"], spell),
						desc = string.format(L["Remove %s from this group."], spell),
						func = function()
							v.auras[spell] = nil;
							StatusAuras.options.buffGroups.args[k].args.auras.args[spell] = nil;
							StatusAuras.options.buffGroups.args[k].args.removeSpell.args[spell] = nil;
						end,
						order = 3
					}
				end

				if (defaultDB.buffGroups[k] == nil or defaultDB.buffGroups[k].auras[spell]==nil) then
					StatusAuras.options.buffGroups.args[k].args.removeSpell.args[spell] = nil;
				end
			end
		end
	end
	
	for typeName, buffType in pairs(StatusAuras.db.buffTypes) do
		StatusAuras:RegisterStatus("statusAura"..typeName, string.format(L["Aura Type: %s"], typeName));
		StatusAuras.options.buffTypes.args[typeName] = {
			type = "group",
			name = typeName,
			desc = string.format(L["Options for %s."], typeName),
			args = {
				color = {
					type = "color",
					name = L["Color"],
					desc = L["Color."],
					get = function()
						local tmpColor = buffType.color;
						return tmpColor[1], tmpColor[2], tmpColor[3], tmpColor[4]
					end,
					set = function(r, g, b, a)
						local tmpColor = buffType.color;
						tmpColor[1], tmpColor[2], tmpColor[3], tmpColor[4] = r, g, b, a or 1
					end,
					hasAlpha = false,
				},
				alpha = {
					type = "range",
					name = L["Alpha"],
					desc = L["Alpha."],
					get = function()
						return buffType.color[4];
					end,
					set = function(v)
						buffType.color[4] = v;
					end,
					min = 0,
					max = 1,
					step = 0.01
				},
				priority = {
					type = "range",
					name = L["Priority"],
					desc = L["Priority."],
					get = function()
						return buffType.priority;
					end,
					set = function(v)
						buffType.priority = v;
					end,
					min = 1,
					max = 99,
					step = 1
				}
			}
		}
	end
	
end