local L = LibStub("AceLocale-3.0"):GetLocale("ProximoGrid", true)
StatusHealth = ProximoGridStatus.NewModule("StatusHealth", {
	unitHealth = {
		useClassColors = true,
		color = {1, 1, 1, 1},
		priority = 90,
		threshold = 80,
		useClassColors = true,
		showAsPerCent = false
	},
	unitHealthDeficit = {
		useClassColors = true,
		color = {1, 1, 1, 1},
		priority = 90,
		threshold = 80,
		useClassColors = true,
		showAsPerCent = false
	},
	unitLowHealth = {
		useClassColors = true,
		color = {1, 1, 1, 1},
		priority = 81,
		threshold = 20,
		showAsPerCent = false,
	},
	unitDeath = {
		useClassColors = true,
		color = {0.5, 0.5, 0.5, 1},
		priority = 92,
	},
	unitFeignDeath = {
		useClassColors = true,
		color = {0.5, 0.5, 0.5, 1},
		priority = 92,
	},
	unitPower= {
		usePowerTypeColors = true,
		color = {0.5, 0.5, 0.5, 1},
		priority = 92,
		threshold = 100,
		showAsPerCent = true
	},
	announcements = {
		["announcementLowHealth"] = {
			color = {1, 0, 0, 1},
			enableSound = true,
			soundFile = "RaidWarning"
		},
		["announcementDeath"] = {
			color = {1, 0, 0, 1},
			enableSound = true,
			soundFile = "Levelup"
		}
	}
});

StatusHealth.header = L["Health/Mana"];
StatusHealth.options = {
	unitHealth = {
		type = "group",
		name = L["Health"],
		desc = string.format(L["Options for the %s status."], L["Health"]),
		args = {
			color = {
				type = "color",
				name = L["Color"],
				desc = L["The color that will be used if 'Use Class Colors' is not set."],
				get = function()
					local tmpColor = StatusHealth.db.unitHealth.color;
					return tmpColor[1], tmpColor[2], tmpColor[3], tmpColor[4]
				end,
				set = function(r, g, b, a)
					local tmpColor = StatusHealth.db.unitHealth.color;
					tmpColor[1], tmpColor[2], tmpColor[3], tmpColor[4] = r, g, b, a or 1
				end,
				hasAlpha = false,
			},
			alpha = {
				type = "range",
				name = L["Alpha"],
				desc = L["Alpha."],
				get = function()
					return StatusHealth.db.unitHealth.color[4];
				end,
				set = function(v)
					StatusHealth.db.unitHealth.color[4] = v;
				end,
				min = 0,
				max = 1,
				step = 0.01
			},
			priority = {
				type = "range",
				name = L["Priority"],
				desc = L["Priority."],
				get = function()
					return StatusHealth.db.unitHealth.priority;
				end,
				set = function(v)
					StatusHealth.db.unitHealth.priority = v;
				end,
				min = 1,
				max = 99,
				step = 1
			},
			threshold = {
				type = "range",
				name = L["Threshold"],
				desc = L["Threshold before this status will be active."],
				get = function()
					return StatusHealth.db.unitHealth.threshold;
				end,
				set = function(v)
					StatusHealth.db.unitHealth.threshold = v;
				end,
				min = 1,
				max = 100,
				step = 1
			},
			useClassColor = {
				type = "toggle",
				name = L["Use Class Colors"],
				desc = L["Use Blizzardss default class colors."],
				get = function()
					return StatusHealth.db.unitHealth.useClassColors;
				end,
				set = function(v)
					StatusHealth.db.unitHealth.useClassColors = v;
				end,
			},
			showAsPerCent = {
				type = "toggle",
				name = L["Show as Per Cent"],
				desc = L["Show it as Per Cent."],
				get = function()
					return StatusHealth.db.unitHealth.showAsPerCent;
				end,
				set = function(v)
					StatusHealth.db.unitHealth.showAsPerCent = v;
				end,
			},
		}
	},
	unitHealthDeficit = {
		type = "group",
		name = L["Health Deficit"],
		desc = string.format(L["Options for the %s status."], L["Health Deficit"]),
		args = {
			color = {
				type = "color",
				name = L["Color"],
				desc = L["The color that will be used if 'Use Class Colors' is not set."],
				get = function()
					local tmpColor = StatusHealth.db.unitHealthDeficit.color;
					return tmpColor[1], tmpColor[2], tmpColor[3], tmpColor[4]
				end,
				set = function(r, g, b, a)
					local tmpColor = StatusHealth.db.unitHealthDeficit.color;
					tmpColor[1], tmpColor[2], tmpColor[3], tmpColor[4] = r, g, b, a or 1
				end,
				hasAlpha = false,
			},
			alpha = {
				type = "range",
				name = L["Alpha"],
				desc = L["Alpha."],
				get = function()
					return StatusHealth.db.unitHealthDeficit.color[4];
				end,
				set = function(v)
					StatusHealth.db.unitHealthDeficit.color[4] = v;
				end,
				min = 0,
				max = 1,
				step = 0.01
			},
			priority = {
				type = "range",
				name = L["Priority"],
				desc = L["Priority."],
				get = function()
					return StatusHealth.db.unitHealthDeficit.priority;
				end,
				set = function(v)
					StatusHealth.db.unitHealthDeficit.priority = v;
				end,
				min = 1,
				max = 99,
				step = 1
			},
			threshold = {
				type = "range",
				name = L["Threshold"],
				desc = L["Threshold before this status will be active."],
				get = function()
					return StatusHealth.db.unitHealthDeficit.threshold;
				end,
				set = function(v)
					StatusHealth.db.unitHealthDeficit.threshold = v;
				end,
				min = 1,
				max = 100,
				step = 1
			},
			useClassColor = {
				type = "toggle",
				name = L["Use Class Colors"],
				desc = L["Use Blizzard's default class colors."],
				get = function()
					return StatusHealth.db.unitHealthDeficit.useClassColors;
				end,
				set = function(v)
					StatusHealth.db.unitHealthDeficit.useClassColors = v;
				end,
			},
			showAsPerCent = {
				type = "toggle",
				name = L["Show as Per Cent"],
				desc = L["Show it as Per Cent."],
				get = function()
					return StatusHealth.db.unitHealthDeficit.showAsPerCent;
				end,
				set = function(v)
					StatusHealth.db.unitHealthDeficit.showAsPerCent = v;
				end,
			},
		}
	},
	unitLowHealth = {
		type = "group",
		name = L["Low Health"],
		desc = string.format(L["Options for the %s status."], L["Low Health"]),
		args = {
			color = {
				type = "color",
				name = L["Color"],
				desc = L["Color."],
				get = function()
					local tmpColor = StatusHealth.db.unitLowHealth.color;
					return tmpColor[1], tmpColor[2], tmpColor[3], tmpColor[4]
				end,
				set = function(r, g, b, a)
					local tmpColor = StatusHealth.db.unitLowHealth.color;
					tmpColor[1], tmpColor[2], tmpColor[3], tmpColor[4] = r, g, b, a or 1
				end,
				hasAlpha = false,
			},
			alpha = {
				type = "range",
				name = L["Alpha"],
				desc = L["Alpha."],
				get = function()
					return StatusHealth.db.unitLowHealth.color[4];
				end,
				set = function(v)
					StatusHealth.db.unitLowHealth.color[4] = v;
				end,
				min = 0,
				max = 1,
				step = 0.01
			},
			priority = {
				type = "range",
				name = L["Priority"],
				desc = L["Priority."],
				get = function()
					return StatusHealth.db.unitLowHealth.priority;
				end,
				set = function(v)
					StatusHealth.db.unitLowHealth.priority = v;
				end,
				min = 1,
				max = 99,
				step = 1
			},
			threshold = {
				type = "range",
				name = L["Threshold"],
				desc = L["Threshold before this status will be active."],
				get = function()
					return StatusHealth.db.unitLowHealth.threshold;
				end,
				set = function(v)
					StatusHealth.db.unitLowHealth.threshold = v;
				end,
				min = 1,
				max = 100,
				step = 1
			},
			showAsPerCent = {
				type = "toggle",
				name = L["Show as Per Cent"],
				desc = L["Show it as Per Cent."],
				get = function()
					return StatusHealth.db.unitLowHealth.showAsPerCent;
				end,
				set = function(v)
					StatusHealth.db.unitLowHealth.showAsPerCent = v;
				end,
			}
		}
	},
	unitPower = {
		type = "group",
		name = L["Mana"],
		desc = string.format(L["Options for the %s status."], L["Mana"]),
		args = {
			color = {
				type = "color",
				name = L["Color"],
				desc = L["The color that will be used if 'Use Class Colors' is not set."],
				get = function()
					local tmpColor = StatusHealth.db.unitPower.color;
					return tmpColor[1], tmpColor[2], tmpColor[3], tmpColor[4]
				end,
				set = function(r, g, b, a)
					local tmpColor = StatusHealth.db.unitPower.color;
					tmpColor[1], tmpColor[2], tmpColor[3], tmpColor[4] = r, g, b, a or 1
				end,
				hasAlpha = false,
			},
			alpha = {
				type = "range",
				name = L["Alpha"],
				desc = L["Alpha."],
				get = function()
					return StatusHealth.db.unitPower.color[4];
				end,
				set = function(v)
					StatusHealth.db.unitPower.color[4] = v;
				end,
				min = 0,
				max = 1,
				step = 0.01
			},
			priority = {
				type = "range",
				name = L["Priority"],
				desc = L["Priority."],
				get = function()
					return StatusHealth.db.unitPower.priority;
				end,
				set = function(v)
					StatusHealth.db.unitPower.priority = v;
				end,
				min = 1,
				max = 99,
				step = 1
			},
			threshold = {
				type = "range",
				name = L["Threshold"],
				desc = L["Threshold before this status will be active."],
				get = function()
					return StatusHealth.db.unitPower.threshold;
				end,
				set = function(v)
					StatusHealth.db.unitPower.threshold = v;
				end,
				min = 1,
				max = 100,
				step = 1
			},
			usePowerTypeColor = {
				type = "toggle",
				name = L["Use Power Type Colors"],
				desc = L["Use the power type's color."],
				get = function()
					return StatusHealth.db.unitPower.usePowerTypeColors;
				end,
				set = function(v)
					StatusHealth.db.unitPower.usePowerTypeColors = v;
				end,
			},
			showAsPerCent = {
				type = "toggle",
				name = L["Show as Per Cent"],
				desc = L["Show it as Per Cent."],
				get = function()
					return StatusHealth.db.unitPower.showAsPerCent;
				end,
				set = function(v)
					StatusHealth.db.unitPower.showAsPerCent = v;
				end,
			},
		}
	},
	unitDeath = {
		type = "group",
		name = L["Death"],
		desc = string.format(L["Options for the %s status."], L["Death"]),
		args = {
			color = {
				type = "color",
				name = L["Color"],
				desc = L["Color."],
				get = function()
					local tmpColor = StatusHealth.db.unitDeath.color;
					return tmpColor[1], tmpColor[2], tmpColor[3], tmpColor[4]
				end,
				set = function(r, g, b, a)
					local tmpColor = StatusHealth.db.unitDeath.color;
					tmpColor[1], tmpColor[2], tmpColor[3], tmpColor[4] = r, g, b, a or 1
				end,
				hasAlpha = false,
			},
			alpha = {
				type = "range",
				name = L["Alpha"],
				desc = L["Alpha."],
				get = function()
					return StatusHealth.db.unitDeath.color[4];
				end,
				set = function(v)
					StatusHealth.db.unitDeath.color[4] = v;
				end,
				min = 0,
				max = 1,
				step = 0.01
			},
			priority = {
				type = "range",
				name = L["Priority"],
				desc = L["Priority."],
				get = function()
					return StatusHealth.db.unitDeath.priority;
				end,
				set = function(v)
					StatusHealth.db.unitDeath.priority = v;
				end,
				min = 1,
				max = 99,
				step = 1
			}
		}
	},
	--unitFeignDeath = {
	--	type = "group",
	---	name = "Feign Death",
	--	desc = "Options for the Feign Death status.",
	--	args = {
	--		color = {
	--			type = "color",
	--			name = "Color",
	--			desc = "Color",
	--			get = function()
	--				local tmpColor = StatusHealth.db.unitFeignDeath.color;
	---				return tmpColor[1], tmpColor[2], tmpColor[3], tmpColor[4]
	---			end,
	--			set = function(r, g, b, a)
	--				local tmpColor = StatusHealth.db.unitFeignDeath.color;
	--				tmpColor[1], tmpColor[2], tmpColor[3], tmpColor[4] = r, g, b, a or 1
	--			end,
	--			hasAlpha = false,
	--		},
	--		alpha = {
	--			type = "range",
	--			name = "Alpha,
	--			desc = "Alpha",
	--			get = function()
	--				return StatusHealth.db.unitFeignDeath.color[4];
	--			end,
	--			set = function(v)
	--				StatusHealth.db.unitFeignDeath.color[4] = v;
	--			end,
	--			min = 0,
	--			max = 1,
	--			step = 0.01
	--		},
	--		priority = {
	--			type = "range",
	--			name = "Priority",
	--			desc = "Priority",
	--			get = function()
	--				return StatusHealth.db.unitFeignDeath.priority;
	--			end,
	--			set = function(v)
	--				StatusHealth.db.unitFeignDeath.priority = v;
	--			end,
	--			min = 1,
	--			max = 99,
	--			step = 1
	--		},
	--	}
	--}
}

function StatusHealth:PROXIMOGRID_UNIT_DIED(unitGUID)
	tmpColor = StatusHealth.db.unitDeath.color;
	r, g, b, a = tmpColor[1], tmpColor[2], tmpColor[3], tmpColor[4];
	StatusHealth:SendStatusGained(unitGUID, unitName, "statusDeath", StatusHealth.db.unitDeath.priority, true, {["r"] = r,["g"] = g,["b"] = b, ["a"] = a}, L["Dead"],  0, 0, nil, 0, 0, 0);
	StatusHealth:SendStatusLost(unitGUID, "statusHealth");
	StatusHealth:SendStatusLost(unitGUID, "statusHealthDeficit");
	StatusHealth:SendStatusLost(unitGUID, "statusLowHealth");
	StatusHealth:SendStatusLost(unitGUID, "statusPower");
end

function StatusHealth:PROXIMOGRID_UNIT_HEALTH_UPDATED(unitID)
	local unitInfo = ProximoGrid.Opponents[unitID];
	local opponent = ProximoGrid.Opponents[unitID];
	local unitHealth = opponent.unitHealth;
	local unitHealthMax = opponent.unitHealthMax;
	local healthOfMax = unitHealth/unitHealthMax;
	local tmpColor, r, g, b, a;
	local text;
	local unitName = opponent.unitName;
	
	--HEALTH STATUS
	if (healthOfMax<=StatusHealth.db.unitHealth.threshold*0.01) then
		if (StatusHealth.db.unitHealth.useClassColors) then
			if (not unitInfo.unitIsPet) then
				r, g, b, a = ProximoGrid:GetColor("class", unitInfo.unitClass);
			else
				r, g, b, a = ProximoGrid:GetColor("creature type", unitInfo.unitCreaturType);
			end
		else
			tmpColor = StatusHealth.db.unitHealth.color;
			r, g, b, a = tmpColor[1], tmpColor[2], tmpColor[3], tmpColor[4];
		end
		if (StatusHealth.db.unitHealth.showAsPerCent) then
			text = (math.floor(healthOfMax*100+0.5)).."%"; 
		else
			text = unitHealth.."";
		end
		StatusHealth:SendStatusGained(unitID, unitName, "statusHealth", StatusHealth.db.unitHealth.priority, true, {["r"] = r,["g"] = g,["b"] = b, ["a"] = a}, text,  unitHealth, unitHealthMax, nil, 0, 0, 0);
	else
		StatusHealth:SendStatusLost(unitID,"statusHealth");
	end
	
	--HEALTH DEFICIT STATUS
	if (healthOfMax<=StatusHealth.db.unitHealthDeficit.threshold*0.01) then
		if (StatusHealth.db.unitHealthDeficit.useClassColors) then
			if (not unitInfo.unitIsPet) then
				r, g, b, a = ProximoGrid:GetColor("class", unitInfo.unitClass);
			else
				r, g, b, a = ProximoGrid:GetColor("creature type", unitInfo.unitCreaturType);
			end
		else
			tmpColor = StatusHealth.db.unitHealthDeficit.color;
			r, g, b, a = tmpColor[1], tmpColor[2], tmpColor[3], tmpColor[4];
		end
		if (StatusHealth.db.unitHealthDeficit.showAsPerCent) then
			text = (math.floor((100-(healthOfMax*100))+0.5)).."%"; 
		else
			text = (unitHealthMax-unitHealth).."";
		end
		StatusHealth:SendStatusGained(unitID, unitName, "statusHealthDeficit", StatusHealth.db.unitHealthDeficit.priority, true, {["r"] = r,["g"] = g,["b"] = b, ["a"] = a}, text,  (unitHealthMax-unitHealth), unitHealthMax, nil, 0, 0, 0);
	else
		StatusHealth:SendStatusLost(unitID,"statusHealthDeficit");
	end
	
	--LOW HEALTH STATUS
	if (healthOfMax<=StatusHealth.db.unitLowHealth.threshold*0.01) then
		local tmpColor = StatusHealth.db.unitLowHealth.color;
		local r, g, b, a = tmpColor[1], tmpColor[2], tmpColor[3], tmpColor[4];
		if (StatusHealth:SendStatusGained(unitID, unitName, "statusLowHealth", StatusHealth.db.unitLowHealth.priority, true, {["r"] = r,["g"] = g,["b"] = b, ["a"] = a}, L["Low Health"],  0, 0, nil, 0, 0, 0)) then
			StatusUnitInfo:SendAnnouncement(string.format(L["Low health: %s"], unitName), "announcementLowHealth");
		end
	else
		StatusHealth:SendStatusLost(unitID,"statusLowHealth");
	end
	
	--DEATH STATUS
	if (unitHealth <= 0 and (not ProximoGrid:inArenaZone() or UnitExists(unitID))) then
		tmpColor = StatusHealth.db.unitDeath.color;
		r, g, b, a = tmpColor[1], tmpColor[2], tmpColor[3], tmpColor[4];
		if (StatusHealth:SendStatusGained(unitID, unitName, "statusDeath", StatusHealth.db.unitDeath.priority, true, {["r"] = r,["g"] = g,["b"] = b, ["a"] = a}, L["Dead"],  0, 0, nil, 0, 0, 0)) then
			StatusUnitInfo:SendAnnouncement(string.format(L["Dead: %s"], unitName), "announcementDeath");
		end
		
	else
		StatusHealth:SendStatusLost(unitID, "statusDeath");
	end	
end

function StatusHealth:PROXIMOGRID_UNIT_POWER_UPDATED(unitID)
	local unitInfo = ProximoGrid.Opponents[unitID];
	local opponent = ProximoGrid.Opponents[unitID];
	local unitPower = opponent.unitPower;
	local unitPowerMax = opponent.unitPowerMax;
	local unitPowerType = opponent.unitPowerType;
	local powerOfMax = unitPower/unitPowerMax;
	local r,g,b,a;

	--POWER STATUS
	if (powerOfMax<=StatusHealth.db.unitPower.threshold*0.01) then
		if (StatusHealth.db.unitPower.usePowerTypeColors) then
			r, g, b, a = ProximoGrid:GetColor("power type", unitInfo.unitPowerType);
		else
			tmpColor = StatusHealth.db.unitPower.color;
			r, g, b, a = tmpColor[1], tmpColor[2], tmpColor[3], tmpColor[4];
			ProximoGrid:Debug(r.." "..g.." "..b);
		end
		if (StatusHealth.db.unitPower.showAsPerCent) then
			text = (math.floor(powerOfMax*100+0.5)).."%"; 
		else
			text = unitPower.."";
		end

		StatusHealth:SendStatusGained(unitID, unitName, "statusPower", StatusHealth.db.unitPower.priority, true, {["r"] = r,["g"] = g,["b"] = b, ["a"] = a}, text,  unitPower, unitPowerMax, nil, 0, 0, 0);
	else
		StatusHealth:SendStatusLost(unitID,"statusPower");
	end
end

function StatusHealth:OnInitialize()
	StatusHealth:RegisterAnnouncement("announcementLowHealth", L["Low Health"])
	StatusHealth:RegisterAnnouncement("announcementDeath", L["Death"])
	StatusHealth:RegisterStatus("statusHealth", L["Health"]);
	StatusHealth:RegisterStatus("statusPower", L["Mana"]);
	StatusHealth:RegisterStatus("statusHealthDeficit", L["Health Deficit"]);
	StatusHealth:RegisterStatus("statusLowHealth", L["Low Health"]);
	StatusHealth:RegisterStatus("statusDeath", L["Death"]);
	--StatusHealth:RegisterStatus("statusFeignDeath", L["Feign Death"]);
	
end

function StatusHealth:OnEnable()
	StatusHealth:RegisterEvent("PROXIMOGRID_UNIT_POWER_UPDATED");
	StatusHealth:RegisterEvent("PROXIMOGRID_UNIT_HEALTH_UPDATED");
	StatusHealth:RegisterEvent("PROXIMOGRID_UNIT_DIED");
end

function StatusHealth:OnDisable()
	StatusHealth:UnregisterEvent("PROXIMOGRID_UNIT_POWER_UPDATED");
	StatusHealth:UnregisterEvent("PROXIMOGRID_UNIT_HEALTH_UPDATED");
	StatusHealth:UnregisterEvent("PROXIMOGRID_UNIT_DIED");
end